SYS1   ;	sys1/asm
 MODI	EQU	0
 MODII	EQU	0
 MODIII	EQU	-1
 	ORG	5000H
 	AND	0F0H		;get command #
 	CP	10H		;entry point?
 	JR	Z,ENTRY
 	CP	20H		;terminate
 	JR	Z,QUIT		;done
 	CP	30H
 	JP	Z,RECEIVE
 	LD	A,47		;illegal command
 	JP	402AH		;error and abort
 QUIT	CALL	4074H
 	CALL	4065H
 	LD	HL,QUITMSG
 	CALL	4030H		;display it
 DEAD	CALL	4018H
 	CP	2
 	JR	NZ,DEAD
 	IF	MODI
 	HALT
 	ENDIF
 	IF	MODIII
 	RST	0
 	ENDIF
 STOP	JR	STOP
 ENTRY	CALL	4074H
 	CALL	4065H		;heading
 	LD	HL,MESG		;message
 	CALL	4030H		;display message
 	LD	B,1		;one key input
 	CALL	4036H		;get from keyboard
 	JP	C,ENTRY		;back to menu
 	JP	Z,ENTRY		;nothing
 	CALL	403FH		;upper case
 	CP	'W'		;who?
 	JR	Z,DOWHO
 	SUB	30H		;remove ascii
 	JP	C,ENTRY
 	CP	10		;check for 0-9
 	JP	NC,ENTRY	;invalid, too big
 	LD	C,A		;save here for test
 	LD	B,0		;for addition
 	LD	HL,CMDTABL	;command table
 	ADD	HL,BC		;point to byte
 	LD	A,(HL)		;get it
 	RST	28H		;go
 DOWHO	LD	A,11H		;return vector
 	LD	(IY+44),A	;save it
 	SET	5,(IY+16)	;system calling system
 	LD	A,45
 	OR	0C0H
 	JP	4027H		;print it
 CMDTABL	DB	21H		;0
 	DB	31H		;1
 	DB	11H		;2
 	DB	11H		;3
 	DB	11H		;4
 	DB	11H		;5
 	DB	11H		;6
 	DB	11H		;7
 	DB	1AH		;8
 	DB	2AH		;9
 RECEIVE	CALL	4074H
 	CALL	4065H
 	LD	HL,MASK10
 	CALL	4030H
 RECBAD	LD	(IY+19),0C0H
 	LD	(IY+20),3CH
 	LD	HL,RECMG
 	CALL	4030H
 	LD	B,2
 	CALL	4036H
 	JP	C,ENTRY
 	JR	Z,RECBAD
 	CALL	VALUE
 	JR	C,RECBAD
 	LD	HL,RECTBL-1
 	LD	B,0
 	LD	A,C
 	OR	A
 	JR	Z,RECBAD
 	CP	21
 	JR	NC,RECBAD
 	ADD	HL,BC
 	LD	A,(HL)
 	RST	28H
 RECTBL	DB	16H	;1
 	DB	25H	;2
 	DB	26H	;3
 	DB	36H	;4
 	DB	65H	;5
 	DB	75H	;6
 	DB	85H	;7
 	DB	45H	;8
 	DB	23H	;9
 	DB	53H	;10
 	DB	12H	;11
 	DB	15H	;12
 	DB	22H	;13
 	DB	32H	;14
 	DB	35H	;15
 	DB	55H	;16
 	DB	13H	;17
 	DB	33H	;18
 	DB	43H	;19
 	DB	11H	;20
 VALUE	LD	BC,0
 	EX	DE,HL
 VALLP	LD	A,(DE)
 	INC	DE
 	CP	13
 	RET	Z
 	CALL	CKVAL
 	RET	C
 	LD	H,B
 	LD	L,C
 	ADD	HL,HL
 	ADD	HL,HL
 	ADD	HL,BC
 	ADD	HL,HL
 	LD	C,A
 	LD	B,0
 	ADD	HL,BC
 	LD	B,H
 	LD	C,L
 	JR	VALLP
 CKVAL	SUB	30H
 	RET	C
 	CP	10
 	CCF
 	RET
 RECMG	DB	1EH,'Choice ? ',3
 MESG	DB	'- Master Program Selection -',10,10
 	DB	'1. Receivable/Payable',9,'6. xxxxxx',10
 	DB	'2. xxxxxx',9,'7. xxxxxx',10
 	DB	'3. xxxxxx',9,'8. Initialize Disk',10
 	DB	'4. xxxxxx',9,'9. Disk Backup',10
 	DB	'5. xxxxxx',9,'0. Exit Program',10,10
 	DB	'Choice ? ',3
 QUITMSG	DB	10,10,'Session Terminated.',13
 MASK10	DB	'- Program Selection Menu-',10,10,10
 	DB	' . . . Accounts Payable . . . . . . . Accounts Receivable . . .',10
 	DB	' 1. Transaction Entry',9,8,8,'.    11. Transaction Entry',10
 	DB	' 2. Transaction Print',9,8,8,'.    12. Transaction Print',10
 	DB	' 3. Transaction F/M',9,8,8,'.    13. Transaction F/M',10
 	DB	' 4. Update',9,8,8,'.    14. Update',10
 	DB	' 5. Check Calculate',9,8,8,'.    15. Ledger',10
 	DB	' 6. Check Register',9,8,8,'.    16. Statements',10
 	DB	' 7. Check Writer',9,8,8,'.    17. Customer F/M',10
 	DB	' 8. Ledger',9,8,8,'.    18. Tax Code F/M',10
 	DB	' 9. Vendor F/M',9,8,8,'. . . . . . . . . . . . . . . .',10
 	DB	'10. Information F/M        .      19. General Information F/M',10
 	DB	'. . . . . . . . . . . . .         20. Exit',3
 	END	5000H
